/* IX Wiosenny Turniej w Programowaniu Zespolowym, Politechnika Poznanska 2005
   Zadanie: Podbj rynku
   Autor: Grzegorz Sobaski
 */
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <deque>
using namespace std;

int main()
{
	int d;
	scanf("%d", &d);
	while (d--) {
		int n, m;
		scanf("%d%d", &n, &m);
		assert(n > 0);
		assert(n <= 10000);
		assert(m >= 0);
		assert(m <= 100000);
		
		int next[10001];
		int prev[10001];
		int pocz[10001];
		int unsorted[100000][2];
		int sorted[100000];
		memset(next, 0, 10001 * sizeof(int));
		memset(prev, 0, 10001 * sizeof(int));

		for (int i = 0; i < m; i++) {
			int a, b;
			scanf("%d%d", &a, &b);
			assert(a > 0);
			assert(a <= n);
			assert(b > 0);
			assert(b <= n);
			assert(a != b);

			next[b]++;
			prev[a]++;
			unsorted[i][0] = a;
			unsorted[i][1] = b;
		}

		int juz[10001];
		memset(juz, 0, 10001 * sizeof(int));

		for (int i = 1; i <= n; i++)
			pocz[i + 1] = pocz[i] + next[i];

		for (int i = 0; i < m; i++) {
			int a = unsorted[i][0];
			int b = unsorted[i][1];
			sorted[pocz[b] + juz[b]++] = a;
		}


		/*
		for (int i = 0; i < m; i++) {
			printf("%d ", sorted[i]);
		}
		printf("\n");

		for (int i = 1; i <= n; i++) {
			printf("%d: ", i);
			for (int j = 0; j < ile[i]; j++)
				printf("%d ", sorted[pocz[i] + j]);
			printf("\n");
		}
		*/

		deque<int> kolejka;

		for (int i = 1; i <= n; i++)
			if (prev[i] == 0)
				kolejka.push_back(i);
		kolejka.push_back(0);

		int max = 0;
		int level = 0;
		bool koniec = false;
		int vertices = 0;
		
		while (true) {
			int v = kolejka[0];
			kolejka.pop_front();

//			printf("%d ", v);

			if (v == 0) {
//				printf("\n");
				if (koniec)
					break;

				if (level > max) {
					max = level;
				}

				koniec = true;
				level = 0;
				kolejka.push_back(0);
				continue;
			}

			koniec = false;
			level++;
			vertices++;
//			printf("lev: %d ", level);

			for (int i = pocz[v]; i < pocz[v] + next[v]; i++) {
				prev[sorted[i]]--;
				if (prev[sorted[i]] == 0)
					kolejka.push_back(sorted[i]);
			}

//			printf("\n");
		}
		if (vertices < n - 1)
			printf("Brak rozwiazania\n");
		else
			printf("%d\n", max);
//		printf("***\n");

	}
	return 0;
}
